Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization.Views/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization.Views/3.3/Properties/AssemblyInfo.cs.frame	(revision 16405)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization.Views/3.3/Properties/AssemblyInfo.cs.frame	(revision 16405)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristiclLab.MathematicalOptimization.Views")]
+[assembly: AssemblyDescription("Views for mathematical optimization")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HEAL")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2018 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("78D3CF45-1EDF-4AF1-B215-EA196A9EC7B1")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.15.$WCREV$")]
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/HeuristicLab.MathematicalOptimization-3.3.csproj
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/HeuristicLab.MathematicalOptimization-3.3.csproj	(revision 16404)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/HeuristicLab.MathematicalOptimization-3.3.csproj	(revision 16405)
@@ -121,54 +121,39 @@
     <Reference Include="System" />
     <Reference Include="System.Core" />
-    <Reference Include="System.Data" />
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Xml" />
+    <Reference Include="WindowsBase" />
   </ItemGroup>
   <ItemGroup>
     <Compile Include="LinearProgramming\Algorithms\Solvers\BopSolver.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\CoinOrSolver.cs" />
-    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\ExternalSolver.cs" />
+    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\ExternalLinearSolver.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\GlopSolver.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\GlpkSolver.cs" />
-    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\IExternalSolver.cs" />
-    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\IIncrementalSolver.cs" />
-    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\ExternalIncrementalSolver.cs" />
-    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\IncrementalSolver.cs" />
+    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\IExternalLinearSolver.cs" />
+    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\IIncrementalLinearSolver.cs" />
+    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\ExternalIncrementalLinearSolver.cs" />
+    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\IncrementalLinearSolver.cs" />
     <Compile Include="LinearProgramming\Algorithms\ProblemType.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\ScipSolver.cs" />
-    <Compile Include="LinearProgramming\Wrapper\BasisStatus.cs" />
+    <Compile Include="LinearProgramming\Problems\CompiledProblemDefinition.cs" />
+    <Compile Include="LinearProgramming\Problems\FileBasedLinearProgrammingProblemDefinition.cs" />
+    <Compile Include="LinearProgramming\Problems\LinearProgrammingProblem.cs" />
+    <Compile Include="LinearProgramming\Algorithms\BasisStatus.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\CplexSolver.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\GurobiSolver.cs" />
-    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\ISolver.cs" />
-    <Compile Include="LinearProgramming\Wrapper\IncrementalityValues.cs" />
-    <Compile Include="LinearProgramming\Wrapper\IntegerParam.cs" />
-    <Compile Include="LinearProgramming\Wrapper\LpAlgorithmValues.cs" />
+    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\ILinearSolver.cs" />
+    <Compile Include="LinearProgramming\Algorithms\IncrementalityValues.cs" />
+    <Compile Include="LinearProgramming\Algorithms\IntegerParam.cs" />
+    <Compile Include="LinearProgramming\Algorithms\LpAlgorithmValues.cs" />
     <Compile Include="LinearProgramming\Problems\ILinearProgrammingProblemDefinition.cs" />
     <Compile Include="LinearProgramming\Algorithms\LinearProgrammingAlgorithm.cs" />
-    <Compile Include="LinearProgramming\Problems\LinearProgrammingProblem.cs" />
-    <Compile Include="LinearProgramming\Wrapper\LinearSolverExtensions.cs" />
-    <Compile Include="LinearProgramming\Wrapper\LinearSolver.cs" />
-    <Compile Include="LinearProgramming\Problems\LinearProgrammingProblemDefintion.cs" />
-    <Compile Include="LinearProgramming\Wrapper\OptimizationProblemType.cs" />
-    <Compile Include="LinearProgramming\Problems\ProblemDefinitionScriptException.cs" />
-    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\Solver.cs" />
-    <Compile Include="LinearProgramming\Wrapper\DoubleParam.cs" />
-    <Compile Include="LinearProgramming\Views\LinearProgrammingProblemDefinitionScriptView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="LinearProgramming\Views\LinearProgrammingProblemDefinitionScriptView.Designer.cs">
-      <DependentUpon>LinearProgrammingProblemDefinitionScriptView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="LinearProgramming\Wrapper\ProtoWriteFormat.cs" />
-    <Compile Include="LinearProgramming\Wrapper\ResultStatus.cs" />
-    <Compile Include="LinearProgramming\Views\LinearProgrammingProblemView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="LinearProgramming\Views\LinearProgrammingProblemView.Designer.cs">
-      <DependentUpon>LinearProgrammingProblemView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="LinearProgramming\Problems\LinearProgrammingProblemDefinitionScript.cs" />
-    <Compile Include="LinearProgramming\Templates\CompiledLinearProgrammingProblemDefinition.cs" />
+    <Compile Include="LinearProgramming\Algorithms\LinearSolverExtensions.cs" />
+    <Compile Include="LinearProgramming\Algorithms\OptimizationProblemType.cs" />
+    <Compile Include="LinearProgramming\Algorithms\Solvers\Base\LinearSolver.cs" />
+    <Compile Include="LinearProgramming\Algorithms\DoubleParam.cs" />
+    <Compile Include="LinearProgramming\Algorithms\ProtoWriteFormat.cs" />
+    <Compile Include="LinearProgramming\Algorithms\ResultStatus.cs" />
+    <Compile Include="LinearProgramming\Problems\ProgrammableLinearProgrammingProblemDefinition.cs" />
+    <Resource Include="LinearProgramming\Templates\CompiledLinearProgrammingProblemDefinition.cs" />
     <Compile Include="LinearProgramming\Templates\ScriptTemplates.Designer.cs">
       <AutoGen>True</AutoGen>
@@ -176,5 +161,5 @@
       <DependentUpon>ScriptTemplates.resx</DependentUpon>
     </Compile>
-    <Compile Include="LinearProgramming\Wrapper\SolverResponseStatus.cs" />
+    <Compile Include="LinearProgramming\Algorithms\SolverResponseStatus.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
@@ -201,7 +186,5 @@
       <Generator>ResXFileCodeGenerator</Generator>
       <LastGenOutput>ScriptTemplates.Designer.cs</LastGenOutput>
-    </EmbeddedResource>
-    <EmbeddedResource Include="LinearProgramming\Views\LinearProgrammingProblemView.resx">
-      <DependentUpon>LinearProgrammingProblemView.cs</DependentUpon>
+      <SubType>Designer</SubType>
     </EmbeddedResource>
   </ItemGroup>
@@ -211,8 +194,4 @@
       <Name>HeuristicLab.Analysis-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.CodeEditor\3.4\HeuristicLab.CodeEditor-3.4.csproj">
-      <Project>{C38691AE-ECB4-489A-A05D-B035554E0168}</Project>
-      <Name>HeuristicLab.CodeEditor-3.4</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
@@ -227,8 +206,4 @@
       <Name>HeuristicLab.Common-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
-      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
-      <Name>HeuristicLab.Core.Views-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
       <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
@@ -239,12 +214,4 @@
       <Name>HeuristicLab.Data-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
-      <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
-      <Name>HeuristicLab.MainForm.WindowsForms-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm\3.3\HeuristicLab.MainForm-3.3.csproj">
-      <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
-      <Name>HeuristicLab.MainForm-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
       <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
@@ -266,8 +233,4 @@
       <Project>{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}</Project>
       <Name>HeuristicLab.Problems.Programmable-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Scripting.Views\3.3\HeuristicLab.Scripting.Views-3.3.csproj">
-      <Project>{0C2917C8-7AA8-4E18-800A-C4D064F992ED}</Project>
-      <Name>HeuristicLab.Scripting.Views-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Scripting\3.3\HeuristicLab.Scripting-3.3.csproj">
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/DoubleParam.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/DoubleParam.cs	(revision 16405)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/DoubleParam.cs	(revision 16405)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+
+  // Enumeration of parameters that take continuous values.
+  public enum DoubleParam {
+
+    // Limit for relative MIP gap.
+    RelativeMipGap = 0,
+
+    // Advanced usage: tolerance for primal feasibility of basic
+    // solutions. This does not control the integer feasibility
+    // tolerance of integer solutions for MIP or the tolerance used
+    // during presolve.
+    PrimalTolerance = 1,
+
+    // Advanced usage: tolerance for dual feasibility of basic solutions.
+    DualTolerance = 2
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/IncrementalityValues.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/IncrementalityValues.cs	(revision 16405)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/IncrementalityValues.cs	(revision 16405)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+
+  public enum IncrementalityValues {
+
+    // Start solve from scratch.
+    IncrementalityOff = 0,
+
+    // Reuse results from previous solve as much as the underlying solver allows.
+    IncrementalityOn = 1
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/IntegerParam.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/IntegerParam.cs	(revision 16405)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/IntegerParam.cs	(revision 16405)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming.Algorithms {
+
+  // Enumeration of parameters that take integer or categorical values.
+  public enum IntegerParam {
+
+    // Advanced usage: presolve mode.
+    Presolve = 1000,
+
+    // Algorithm to solve linear programs.
+    LpAlgorithm = 1001,
+
+    // Advanced usage: incrementality from one solve to the next.
+    Incrementality = 1002,
+
+    // Advanced usage: enable or disable matrix scaling.
+    Scaling = 1003
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LinearProgrammingAlgorithm.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LinearProgrammingAlgorithm.cs	(revision 16404)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LinearProgrammingAlgorithm.cs	(revision 16405)
@@ -26,12 +26,9 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.MathematicalOptimization.LinearProgramming.Algorithms.Solvers;
-using HeuristicLab.MathematicalOptimization.LinearProgramming.Algorithms.Solvers.Base;
-using HeuristicLab.MathematicalOptimization.LinearProgramming.Problems;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming.Algorithms {
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
 
   [Item("Linear/Mixed Integer Programming (LP/MIP)", "Linear/mixed integer programming implemented in several solvers. " +
@@ -45,4 +42,7 @@
 
     [Storable]
+    private readonly IFixedValueParameter<FileValue> exportModelParam;
+
+    [Storable]
     private readonly IFixedValueParameter<EnumValue<LpAlgorithmValues>> lpAlgorithmParam;
 
@@ -60,27 +60,22 @@
 
     [Storable]
-    private IConstrainedValueParameter<ISolver> solverParam;
-
-    [Storable]
     private readonly IFixedValueParameter<TimeSpanValue> timeLimitParam;
 
-    public IConstrainedValueParameter<ISolver> SolverParameter {
-      get => solverParam;
-      set => solverParam = value;
-    }
+    [Storable]
+    private IConstrainedValueParameter<ILinearSolver> linearSolverParam;
 
     public LinearProgrammingAlgorithm() {
-      Parameters.Add(solverParam =
-        new ConstrainedValueParameter<ISolver>(nameof(Solver), "The solver used to solve the model."));
-
-      ISolver defaultSolver;
-      solverParam.ValidValues.Add(new BopSolver());
-      solverParam.ValidValues.Add(defaultSolver = new CoinOrSolver());
-      solverParam.ValidValues.Add(new CplexSolver());
-      solverParam.ValidValues.Add(new GlopSolver());
-      solverParam.ValidValues.Add(new GlpkSolver());
-      solverParam.ValidValues.Add(new GurobiSolver());
-      solverParam.ValidValues.Add(new ScipSolver());
-      solverParam.Value = defaultSolver;
+      Parameters.Add(linearSolverParam =
+        new ConstrainedValueParameter<ILinearSolver>(nameof(LinearSolver), "The solver used to solve the model."));
+
+      ILinearSolver defaultSolver;
+      linearSolverParam.ValidValues.Add(new BopSolver());
+      linearSolverParam.ValidValues.Add(defaultSolver = new CoinOrSolver());
+      linearSolverParam.ValidValues.Add(new CplexSolver());
+      linearSolverParam.ValidValues.Add(new GlopSolver());
+      linearSolverParam.ValidValues.Add(new GlpkSolver());
+      linearSolverParam.ValidValues.Add(new GurobiSolver());
+      linearSolverParam.ValidValues.Add(new ScipSolver());
+      linearSolverParam.Value = defaultSolver;
 
       Parameters.Add(relativeGapToleranceParam = new FixedValueParameter<PercentValue>(nameof(RelativeGapTolerance),
@@ -102,4 +97,14 @@
       Parameters.Add(scalingParam = new FixedValueParameter<BoolValue>(nameof(Scaling),
         "Advanced usage: enable or disable matrix scaling.", new BoolValue()));
+      Parameters.Add(exportModelParam =
+        new FixedValueParameter<FileValue>(nameof(ExportModel),
+          "Path of the file the model should be exported to. Run the algorithm to export the model.",
+          new FileValue {
+            SaveFile = true,
+            FileDialogFilter = "CPLEX LP File (*.lp)|*.lp|" +
+                               "Mathematical Programming System File (*.mps)|*.mps|" +
+                               "Google OR-Tools Protocol Buffers Text File (*.prototxt)|*.prototxt|" +
+                               "Google OR-Tools Protocol Buffers Binary File (*.bin)|*.bin"
+          }));
 
       Problem = new LinearProgrammingProblem();
@@ -113,5 +118,5 @@
     protected LinearProgrammingAlgorithm(LinearProgrammingAlgorithm original, Cloner cloner)
       : base(original, cloner) {
-      solverParam = cloner.Clone(original.solverParam);
+      linearSolverParam = cloner.Clone(original.linearSolverParam);
       relativeGapToleranceParam = cloner.Clone(original.relativeGapToleranceParam);
       timeLimitParam = cloner.Clone(original.timeLimitParam);
@@ -121,4 +126,5 @@
       primalToleranceParam = cloner.Clone(original.primalToleranceParam);
       scalingParam = cloner.Clone(original.scalingParam);
+      exportModelParam = cloner.Clone(original.exportModelParam);
     }
 
@@ -128,4 +134,19 @@
     }
 
+    public string ExportModel {
+      get => exportModelParam.Value.Value;
+      set => exportModelParam.Value.Value = value;
+    }
+
+    public ILinearSolver LinearSolver {
+      get => linearSolverParam.Value;
+      set => linearSolverParam.Value = value;
+    }
+
+    public IConstrainedValueParameter<ILinearSolver> LinearSolverParameter {
+      get => linearSolverParam;
+      set => linearSolverParam = value;
+    }
+
     public LpAlgorithmValues LpAlgorithm {
       get => lpAlgorithmParam.Value.Value;
@@ -162,12 +183,7 @@
     }
 
-    public ISolver Solver {
-      get => solverParam.Value;
-      set => solverParam.Value = value;
-    }
-
-    public override bool SupportsPause => Solver.SupportsPause;
-
-    public override bool SupportsStop => Solver.SupportsStop;
+    public override bool SupportsPause => LinearSolver.SupportsPause;
+
+    public override bool SupportsStop => LinearSolver.SupportsStop;
 
     public TimeSpan TimeLimit {
@@ -180,5 +196,5 @@
     public override void Pause() {
       base.Pause();
-      Solver.InterruptSolve();
+      LinearSolver.InterruptSolve();
     }
 
@@ -187,5 +203,5 @@
       Results.Clear();
 
-      foreach (var solver in solverParam.ValidValues) {
+      foreach (var solver in linearSolverParam.ValidValues) {
         solver.Reset();
       }
@@ -194,8 +210,20 @@
     public override void Stop() {
       base.Stop();
-      Solver.InterruptSolve();
-    }
-
-    protected override void Run(CancellationToken cancellationToken) => Solver.Solve(this, cancellationToken);
+      LinearSolver.InterruptSolve();
+    }
+
+    protected override void Run(CancellationToken cancellationToken) {
+      LinearSolver.PrimalTolerance = PrimalTolerance;
+      LinearSolver.DualTolerance = DualTolerance;
+      LinearSolver.LpAlgorithm = LpAlgorithm;
+      LinearSolver.Presolve = Presolve;
+      LinearSolver.RelativeGapTolerance = RelativeGapTolerance;
+      LinearSolver.Scaling = Scaling;
+      LinearSolver.TimeLimit = TimeLimit;
+      LinearSolver.ExportModel = ExportModel;
+      var executionTime = ExecutionTime;
+      ExecutionTimeChanged += (sender, args) => executionTime = ExecutionTime;
+      LinearSolver.Solve(Problem.ProblemDefinition, ref executionTime, Results, cancellationToken);
+    }
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LpAlgorithmValues.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LpAlgorithmValues.cs	(revision 16405)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LpAlgorithmValues.cs	(revision 16405)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+
+  public enum LpAlgorithmValues {
+    DualSimplex = 10,
+    PrimalSimplex = 11,
+    BarrierAlgorithm = 12
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs	(revision 16404)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs	(revision 16405)
@@ -20,5 +20,5 @@
 #endregion
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming.Algorithms {
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
 
   public enum ProblemType {
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs	(revision 16405)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProtoWriteFormat.cs	(revision 16405)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+
+  public enum ProtoWriteFormat {
+    ProtoText,
+    ProtoBinary,
+    Json
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs	(revision 16405)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/SolverResponseStatus.cs	(revision 16405)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+
+  public enum SolverResponseStatus {
+    Optimal = 0,
+    Feasible = 1,
+    Infeasible = 2,
+    Unbounded = 3,
+    Abnormal = 4,
+    ModelInvalid = 5,
+    NotSolved = 6,
+    SolverTypeUnavailable = 7,
+    ModelInvalidSolutionHint = 84,
+    ModelInvalidSolverParameters = 85,
+    ModelIsValid = 97,
+    UnknownStatus = 99
+  }
+}
